#include<iostream>
#include<algorithm>
#include<random>
using namespace std;
const int MAXN=100005;
struct point{
	long long x,y;
	point(){};
	point(long long a,long long b){
		x=a;
		y=b;
	}
};
int dim;
bool cmp(point a,point b){
	if(dim==0){
		if(a.x==b.x){
			return a.y<b.y;
		}
		return a.x<b.x;
	}else{
		if(a.y==b.y){
			return a.x<b.x;
		}
		return a.y<b.y;
	}
}
point tree[4*MAXN];
long long minX[4*MAXN],minY[4*MAXN],ans;
point downLeft[MAXN];
void buildTree(int from,int to,int ind,int lvl){
	if(from>=to){
		minX[ind]=1<<30;
		minY[ind]=1<<30;
		return;
	}
	if(from+1==to){
		tree[ind]=downLeft[from];
		minX[ind]=downLeft[from].x;
		minY[ind]=downLeft[from].y;
		return;
	}
	dim=lvl%2;
	sort(downLeft+from,downLeft+to,cmp);
	int mid=(from+to)/2;
	tree[ind]=downLeft[mid];
	buildTree(from,mid,2*ind,lvl+1);
	buildTree(mid,to,2*ind+1,lvl+1);
	minX[ind]=min(minX[2*ind],minX[2*ind+1]);
	minY[ind]=min(minY[2*ind],minY[2*ind+1]);
}
long long area(point a,point b){
	if(a.x>=b.x||a.y>=b.y) return -1;
	return (b.x-a.x)*(b.y-a.y);
}
void search(int from,int to,int ind,int lvl,point a){
	if(from>=to) return;
	if(from+1==to){
		ans=max(ans,area(tree[ind],a));
		return;
	}
	int dim=lvl%2;
	int mid=(from+to)/2;
	if(dim==0){
		if(tree[ind].x<a.x&&minY[2*ind+1]<a.y){
			if(area(point(tree[ind].x,minY[2*ind+1]),a)>ans){
				search(mid,to,2*ind+1,lvl+1,a);
			}
		}
	}else{
		if(tree[ind].y<a.y&&minX[2*ind+1]<a.x){
			if(area(point(minX[2*ind+1],tree[ind].y),a)>ans){
				search(mid,to,2*ind+1,lvl+1,a);
			}
		}
	}
	if(area(point(minX[2*ind],minY[2*ind]),a)>ans){
		search(from,mid,2*ind,lvl+1,a);
	}
}
point upRight[MAXN];
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	mt19937_64 gen(13);
	int n,m;
	cin>>n>>m;
	for(int i=0;i<n;i++){
		cin>>downLeft[i].x>>downLeft[i].y;
	}
	buildTree(0,n,1,0);

	for(int j=0;j<m;j++){
		cin>>upRight[j].x>>upRight[j].y;
	}
	shuffle(upRight,upRight+m,gen);
	for(int j=m-1;j>=0;j--){
		search(0,n,1,0,upRight[j]);
	}
	cout<<ans<<"\n";
	return 0;
}
