#include <iostream>
#include <cstdint>
#include <vector> //shefa <3
#include <algorithm>

struct Point { //shefa <3
	uint64_t x, y;
	bool t; // true for bottom, false for top
	Point(uint64_t pX = 0, uint64_t pY = 0, bool pT = false): 
		x(pX), y(pY), t(pT) {}

	friend bool operator< (const Point &a, const Point &b) {
		if (a.x != b.x) {
			return a.x < b.x;
		} else if (a.t != b.t) {
			return a.t < b.t;
		} else {
			return a.y < b.y;
		}
	}
};

std::vector<Point> allPoints;
std::vector<Point> actBot;

void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);
	
	uint32_t botCnt, topCnt;
	std::cin >> botCnt >> topCnt;
	allPoints.resize(botCnt + topCnt);

	for (uint32_t i = 0;i < botCnt;i++) {
		std::cin >> allPoints[i].x >> allPoints[i].y;
		allPoints[i].t = true;
	}
	for (uint32_t i = botCnt;i < botCnt + topCnt;i++) {
		std::cin >> allPoints[i].x >> allPoints[i].y;
		allPoints[i].t = false;
	}
}

uint64_t area(const Point &bot, const Point &top) {
	if (top.y <= bot.y) {
		return 0;
	} else {
		return (top.x - bot.x) * (top.y - bot.y);
	}
}

uint64_t find_area(const Point &top) {
	if ((actBot.empty()) || (actBot.back().y >= top.y)) {
		return 0;
	}
	uint32_t l = 0;
	uint32_t h = actBot.size() - 1;
	while (h - l > 2) {
		uint32_t s = (h - l + 1) / 3;
		uint32_t m1 = l + s;
		uint32_t m2 = m1 + s;

		//std::cerr << l << " " << h << " " << m1 << " " << m2 << std::endl;

		uint64_t s1 = area(actBot[m1], top);
		uint64_t s2 = area(actBot[m2], top);

		if (s1 < s2) {
			l = m1;
		} else {
			h = m2;
		}
	}

	uint64_t best = 0;
	for (uint32_t i = l;i <= h;i++) {
		best = std::max(best, area(actBot[i], top));
	}
	return best;
}

uint64_t calc_ans() {
	std::sort(allPoints.begin(), allPoints.end());
	//std::cerr << "my dick is big" << std::endl;
	uint64_t ans = 0;

	for (const Point &i : allPoints) {
		if (i.t) {
			if ((actBot.empty()) || (i.y < actBot.back().y)) {
				actBot.push_back(i);
			}
		} else {
			ans = std::max(ans, find_area(i));
		}
	}
	return ans;
}

int main() {
	input();

	//std::cerr << "sex" << std::endl;
	std::cout << calc_ans() << "\n";
}
