#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>

const uint32_t MAX_N = 102;

struct Frame {
	uint32_t x1, y1;
	uint32_t x2, y2;

	Frame(uint32_t px1 = 0, uint32_t py1 = 0, uint32_t px2 = 0, uint32_t py2 = 0):
		x1(px1), y1(py1), x2(px2), y2(py2) {}
};

std::vector<Frame> ans;

char table[MAX_N][MAX_N];
uint32_t w, h;

void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);
	std::cin >> h >> w;

	for (uint32_t y = 0;y < h;y++) {
		for (uint32_t x = 0;x < w;x++) {
			std::cin >> table[x][y];
		}
	}
}

void print_table() {
	for (uint32_t x = 0;x < w;x++) {
		std::cerr << "=";
	}
	std::cerr << "\n";
	for (uint32_t y = 0;y < h;y++) {
		for (uint32_t x = 0;x < w;x++) {
			std::cerr << table[x][y];
		}
		std::cerr << "\n";
	}
}

void use_frame(uint32_t x1, uint32_t y1, uint32_t x2, uint32_t y2) {
	for (uint32_t x = x1;x <= x2;x++) {
		table[x][y1] = table[x][y2] = '?';
	}
	for (uint32_t y = y1;y <= y2;y++) {
		table[x1][y] = table[x2][y] = '?';
	}
	//std::cerr << "(" << x1 << " " << y1 << ") (" << x2 << " " << y2 <<  ")\n";
	ans.push_back(Frame(x1, y1, x2, y2));
	//print_table();
}

bool find_frame() {
	for (uint32_t x1 = 0;x1 < w;x1++) {
		for (uint32_t y1 = 0;y1 < h;y1++) {
			if ((table[x1][y1] != '1') && (table[x1][y1] != '?')) {
				continue;
			}
			uint32_t topCnt = table[x1][y1] == '1';
			for (uint32_t x2 = x1 + 1;x2 < w;x2++) {
				if (table[x2][y1] == '-') {
					topCnt++;
					continue;
				} else if ((table[x2][y1] != '?') && (table[x2][y1] != '2')) {
					break;
				}
				if (table[x2][y1] == '2') {
					topCnt++;
				}
				uint32_t sideCnt = 0;
				for (uint32_t y2 = y1 + 1;y2 < h;y2++) {
					if ((table[x1][y2] != '4') && (table[x1][y2] != '?')) {
						if (table[x1][y2] == '|') {
							sideCnt++;
							continue;
						} else {
							break;
						}
					}
					if ((table[x2][y2] != '3') && (table[x2][y2] != '?')) {
						if (table[x2][y2] == '|') {
							sideCnt++;
							continue;
						} else {
							break;
						}
					}
					if (table[x1][y2] == '4') {
						sideCnt++;
					}
					if (table[x2][y2] == '3') {
						sideCnt++;
					}
					bool ok = true;
					uint32_t botCnt = 0;

					/*for (uint32_t i = y1 + 1;i < y2;i++) {
						if (table[x1][i] == '|') {
							curCnt++;
						} else if (table[x1][i] != '?') {
							ok = false;
							break;
						}
						if (table[x2][i] == '|') {
							curCnt++;
						} else if (table[x2][i] != '?') {
							ok = false;
							break;
						}
					}*/

					for (uint32_t i = x1 + 1;i < x2;i++) {
						if (table[i][y2] == '-') {
							botCnt++;
						} else if (table[i][y2] != '?') {
							ok = false;
							break;
						}
					}
					if ((ok) && (botCnt + topCnt + sideCnt > 0)) {
						use_frame(x1, y1, x2, y2);
						return true;
					}


					if (table[x1][y2] == '4') {
						break;
					}
					if (table[x2][y2] == '3') {
						break;
					}

				}
				if (table[x2][y1] == '2') {
					break;
				}
			}
		}
	}
	return false;
}

void print_ans() {
	std::reverse(ans.begin(), ans.end());
	std::cout << ans.size() << "\n";
	for (const Frame &f : ans) {
		std::cout << f.y1 << " " << f.x1 << " " << f.y2 << " " << f.x2 << "\n";
	}
}

int main() {
	input();
	while (find_frame());
	print_ans();
}
