# include <cstdio>
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;

int n[2];

pair <int, int> p[2][MAX_N];

long long cross (pair <long long, long long> aa, pair <long long, long long> bb)
{
    return aa.first * bb.second - aa.second * bb.first;
}

bool f;

bool cmp (pair <int, int> x, pair <int, int> y)
{
    long long cr = cross ({x.first - p[f][0].first, x.second - p[f][0].second}, {y.first - p[f][0].first, y.second - p[f][0].second});
    return ((cr > 0) || (!cr && abs (x.first - p[f][0].first) < abs (y.first - p[f][0].first)));
}

bool cmp_sm (pair <int, int> x, pair <int, int> y)
{
    return (long long) x.first * x.second < (long long) y.first * y.second;
}

int main ()
{
    int i, id[2] = {0, 0}, j;
    scanf ("%d%d", &n[0], &n[1]);

    vector <pair <int, int> > ch[2];

    for (j = 0; j < 2; j ++)
    {
        for (i = 0; i < n[j]; i ++)
        {
            scanf ("%d%d", &p[j][i].first, &p[j][i].second);
            if (p[j][id[j]].second > p[j][i].second || (p[j][id[j]].second == p[j][i].second && p[j][id[j]].first > p[j][i].first))
                id[j] = i;
        }

        f = j;

        swap (p[j][id[j]], p[j][0]);
        sort (p[j] + 1, p[j] + n[j], cmp);


        ch[j].push_back (p[j][0]);

        pair <int, int> a, b;

        for (i = 1; i < n[j]; i ++)
        {
            while (ch[j].size () > 1)
            {
                a = ch[j][ch[j].size () - 2];
                b = ch[j][ch[j].size () - 1];
                if (cross ({b.first - a.first, b.second - a.second}, {p[j][i].first - a.first, p[j][i].second - a.second}) < 0)
                    ch[j].pop_back ();
                else
                    break;
            }

            ch[j].push_back (p[j][i]);
        }

        ///for (i = 0; i < (int) ch[j].size (); i ++)
        ///    printf ("%d %d\n", ch[j][i].first, ch[j][i].second);
    }

    /// slow

    /**
    sort (ch[0].begin (), ch[0].end (), cmp_sm);
    sort (ch[1].begin (), ch[1].end (), cmp_sm);

    long long ans = 0;

    for (i = 0; i < (int) ch[0].size (); i ++)
        for (j = (int) ch[1].size () - 1; j >= 0 && (long long) ch[1][j].first * ch[1][j].second >= ans; j --)
        {
            if ((ch[1][j].first > ch[0][i].first) && ans < (long long) (ch[1][j].first - ch[0][i].first) * (ch[1][j].second - ch[0][i].second))
                ans = (ch[1][j].first - ch[0][i].first) * (ch[1][j].second - ch[0][i].second);
        }
    **/

    sort (p[0], p[0] + n[0], cmp_sm);
    sort (p[1], p[1] + n[1], cmp_sm);

    long long ans = 0;

    for (i = 0; i < n[0]; i ++)
        for (j = n[1] - 1; j >= 0; j --)
        {
            if ((p[1][j].first > p[0][i].first) && ans < (long long) (p[1][j].first - p[0][i].first) * (p[1][j].second - p[0][i].second))
                ans = (p[1][j].first - p[0][i].first) * (p[1][j].second - p[0][i].second);
        }


    printf ("%lld\n", ans);

    return 0;
}
