# include <cstdio>
# include <algorithm>

using namespace std;

const int MAX_N = 128;
const int MAX_M = 128;
const int MAX_A = 600;

int n, m;

char c[MAX_N][MAX_M];

int ans;
pair <int, int> st[MAX_A], en[MAX_A];

int h[MAX_N][MAX_M];
int v[MAX_N][MAX_M];

int noh[MAX_N][MAX_M];
int nov[MAX_N][MAX_M];

void init ()
{
    int i, j, k;
    for (i = 1; i <= n; i ++)
    {
        h[i][0] = 0;
        for (j = 1; j <= m; j ++)
        {
            h[i][j] = h[i][j - 1];
            if (c[i][j] == '-')
                h[i][j] ++;
        }
        noh[i][m] = m + 1;
        for (j = m - 1; j >= 1; j --)
        {
            noh[i][j] = noh[i][j + 1];
            if (c[i][j + 1] == '.' || (c[i][j + 1] > '0' && c[i][j + 1] < '5') || c[i][j + 1] == '|')
                noh[i][j] = j + 1;
        }
    }

    for (i = 1; i <= m; i ++)
    {
        v[0][i] = 0;
        for (j = 1; j <= n; j ++)
        {
            v[j][i] = v[j - 1][i];
            if (c[j][i] == '|')
                v[j][i] ++;
        }

        nov[n][i] = n + 1;
        for (j = n - 1; j >= 1; j --)
        {
            nov[j][i] = nov[j + 1][i];
            if (c[j + 1][i] == '.' || (c[j + 1][i] > '0' && c[j + 1][i] < '5') || c[j + 1][i] == '-')
                nov[j][i] = j + 1;
        }
    }
}

bool find_frame ()
{
    int i, j, s, best = -1, fl = false;
    pair <int, int> pst, pen;
    for (s = (max (m, n)); s >= 2 && !fl; s --)
    {
        for (i = 1; i + s - 1 <= n && !fl; i ++)
            for (j = 1; j + s - 1 <= m; j ++)
            {
                if (!(c[i][j] == '1' || c[i][j] == '#'))
                    continue;
                if (!(c[i][j + s - 1] == '2' || c[i][j + s - 1] == '#'))
                    continue;
                if (!(c[i + s - 1][j + s - 1] == '3' || c[i + s - 1][j + s - 1] == '#'))
                    continue;
                if (!(c[i + s - 1][j] == '4' || c[i + s - 1][j] == '#'))
                    continue;
                if (nov[i][j] < i + s - 1)
                    continue;
                if (nov[i][j + s - 1] < i + s - 1)
                    continue;
                if (noh[i][j] < j + s - 1)
                    continue;
                if (noh[i + s - 1][j] < j + s - 1)
                    continue;
                int crr = (v[i + s - 1][j] - v[i - 1][j]) + (v[i + s - 1][j + s - 1] - v[i - 1][j + s - 1]) +
                          (h[i][j + s - 1] - h[i][j - 1]) + (h[i + s - 1][j + s - 1] - h[i + s - 1][j - 1]);
                ///printf ("%d %d %d %d\n", i, j, s, crr);
                if (c[i][j] == '1')
                    crr ++;
                if (c[i][j + s - 1] == '2')
                    crr ++;
                if (c[i + s - 1][j + s - 1] == '3')
                    crr ++;
                if (c[i + s - 1][j] == '4')
                    crr ++;

                if (crr >= 4)
                {
                    fl = true;
                    pst = {i, j};
                    pen = {i + s - 1, j + s - 1};
                    break;
                }


                if (best < crr)
                {
                    best = crr;

                    pst = {i, j};
                    pen = {i + s - 1, j + s - 1};
                }
            }
    }


    if (best <= 0 && !fl)
        return false;

    st[++ ans] = pst;
    en[ans] = pen;

    for (i = pst.first; i <= pen.first; i ++)
        c[i][pst.second] = c[i][pen.second] = '#';

    for (i = pst.second; i <= pen.second; i ++)
        c[pst.first][i] = c[pen.first][i] = '#';

    ///printf ("%d %d %d %d %d\n", best, pst.first, pst.second, pen.first, pen.second);


    ///for (i = 1; i <= n; i ++)
    ///    printf ("%s\n", c[i] + 1);


    return true;
}

int main ()
{
    int i, j;

    scanf ("%d%d", &n, &m);

    for (i = 1; i <= n; i ++)
        scanf ("%s", c[i] + 1);

    init ();
    while (find_frame () && ans < 600)
        init ();

    printf ("%d\n", ans);

    for (i = ans; i >= 1; i --)
        printf ("%d %d %d %d\n", st[i].first - 1, st[i].second - 1, en[i].first - 1, en[i].second - 1);

    return 0;
}
/**
5 5
1--2.
|.1-2
|.|||
4-4-3
.....

10 10
..1-1----2
1-------2|
1----2--||
||||||..||
||||||..||
|-|-4|--|3
||||||--||
4----3--||
||4-----|3
4-------3.
**/
