# include <cstdio>
# include <algorithm>

using namespace std;

const int MAX_N = 102;
const int MAX_M = 102;
const int MAX_A = 600;

int n, m;

char c[MAX_N][MAX_M];

int ans;
pair <int, int> st[MAX_A], en[MAX_A];

int h[MAX_N][MAX_M];
int v[MAX_N][MAX_M];

int noh[MAX_N][MAX_M];
int nov[MAX_N][MAX_M];

inline void init ()
{
    int i, j, k;
    for (i = n; i >= 1; i --)
    {
        for (j = m; j >= 1; j --)
        {
            v[i][j] = v[i + 1][j];
            h[i][j] = h[i][j + 1];
            if (c[i][j] == '-')
                h[i][j] ++;
            else
                if (c[i][j] == '|')
                    v[i][j] ++;

            noh[i][j] = noh[i][j + 1];
            if (c[i][j + 1] == '.' || (c[i][j + 1] > '0' && c[i][j + 1] < '5') || c[i][j + 1] == '|')
                noh[i][j] = j + 1;

            nov[i][j] = nov[i + 1][j];

            if (c[i + 1][j] == '.' || (c[i + 1][j] > '0' && c[i + 1][j] < '5') || c[i + 1][j] == '-')
                nov[i][j] = i + 1;
            ///printf ("%d %d %d %d %d %d\n", i, j, v[i][j], h[i][j], nov[i][j], noh[i][j]);
        }
    }
}

bool find_frame ()
{
    int i, j, s, best = -1;
    pair <int, int> pst, pen;
    for (s = (max (m, n)); s >= 2 && best < 16; s --)
    {
        for (i = 1; i + s - 1 <= n && best < 16; i ++)
            for (j = 1; j + s - 1 <= m && best < 16; j ++)
            {
                if (!(c[i][j] == '1' || c[i][j] == '#'))
                    continue;
                if (!(c[i][j + s - 1] == '2' || c[i][j + s - 1] == '#'))
                    continue;
                if (!(c[i + s - 1][j + s - 1] == '3' || c[i + s - 1][j + s - 1] == '#'))
                    continue;
                if (!(c[i + s - 1][j] == '4' || c[i + s - 1][j] == '#'))
                    continue;
                if (nov[i][j] < i + s - 1)
                    continue;
                if (nov[i][j + s - 1] < i + s - 1)
                    continue;
                if (noh[i][j] < j + s - 1)
                    continue;
                if (noh[i + s - 1][j] < j + s - 1)
                    continue;
                int crr = (v[i][j] - v[i + s][j]) + (v[i][j + s - 1] - v[i + s][j + s - 1]) +
                          (h[i][j] - h[i][j + s]) + (h[i + s - 1][j] - h[i + s - 1][j + s]);
                ///printf ("%d %d %d %d\n", i, j, s, crr);
                if (c[i][j] == '1')
                    crr ++;
                if (c[i][j + s - 1] == '2')
                    crr ++;
                if (c[i + s - 1][j + s - 1] == '3')
                    crr ++;
                if (c[i + s - 1][j] == '4')
                    crr ++;
                if (best < crr)
                {
                    best = crr;

                    pst = {i, j};
                    pen = {i + s - 1, j + s - 1};
                }
            }
    }


    if (best <= 0)
        return false;

    st[++ ans] = pst;
    en[ans] = pen;

    for (i = pst.first; i <= pen.first; i ++)
        c[i][pst.second] = c[i][pen.second] = '#';

    for (i = pst.second; i <= pen.second; i ++)
        c[pst.first][i] = c[pen.first][i] = '#';

    ///printf ("%d %d %d %d %d\n", best, pst.first, pst.second, pen.first, pen.second);


    ///for (i = 1; i <= n; i ++)
    ///    printf ("%s\n", c[i] + 1);


    return true;
}

int main ()
{
    int i, j;

    scanf ("%d%d", &n, &m);

    for (i = 1; i <= n; i ++)
    {
        scanf ("%s", c[i] + 1);
        noh[i][m + 1] = m + 1;
    }
    for (i = 1; i <= m; i ++)
        nov[n + 1][i] = n + 1;
    init ();
    while (find_frame () && ans < 600)
        init ();

    printf ("%d\n", ans);

    for (i = ans; i >= 1; i --)
        printf ("%d %d %d %d\n", st[i].first - 1, st[i].second - 1, en[i].first - 1, en[i].second - 1);

    return 0;
}
/**
5 5
1--2.
|.1-2
|.|||
4-4-3
.....

10 10
..1-1----2
1-------2|
1----2--||
||||||..||
||||||..||
|-|-4|--|3
||||||--||
4----3--||
||4-----|3
4-------3.
**/
