#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 105;
const int32_t MAX_M = 105;

class Rectangle {
public:
	int32_t x1, y1, x2, y2;

	Rectangle(int32_t x1 = 0, int32_t y1 = 0, int32_t x2 = 0, int32_t y2 = 0) : x1(x1), y1(y1), x2(x2), y2(y2) {
		
	}
};

char board[MAX_N][MAX_M], initBoard[MAX_N][MAX_M];
int32_t n, m;
vector< Rectangle > rects;

void FindRect() {
	for(int32_t i = 1; i <= n; i++) {
		for(int32_t j = 1; j <= m; j++) {
			if(board[i][j] == '1' || board[i][j] == ' ') {
				for(int32_t len = 2; len <= min(n - i, m - j) + 1; len++) {
					int32_t p = i + len - 1;
					int32_t q = j + len - 1;
					
					if(board[p][j] != '4' && board[p][j] != ' ') {
						continue;
					}
					else if(board[p][q] != '3' && board[p][q] != ' ') {
						continue;
					}
					else if(board[i][q] != '2' && board[i][q] != ' ') {
						continue;
					}

					bool hasNonSpace = false, isOk = true;
					for(int32_t i1 = i + 1; i1 <= p - 1; i1++) {
						if(board[i1][j] != ' ' || board[i1][q] != ' ') {
							hasNonSpace = true;
						}
						
						if(board[i1][j] != ' ' && board[i1][j] != '|') {
							isOk = false;
						}
						if(board[i1][q] != ' ' && board[i1][q] != '|') {
							isOk = false;
						}
					}

					for(int32_t j1 = j + 1; j1 <= q - 1; j1++) {
						if(board[i][j1] != ' ' || board[p][j1] != ' ') {
							hasNonSpace = true;
						}

						if(board[i][j1] != ' ' && board[i][j1] != '-') {
							isOk = false;
						}
						if(board[p][j1] != ' ' && board[p][j1] != '-') {
							isOk = false;
						}
					}

					if(!isOk || !hasNonSpace) {
						continue;
					}
					else {
						for(int32_t i1 = i; i1 <= p; i1++) {
							board[i1][j] = ' ';
							board[i1][q] = ' ';
						}
						for(int32_t j1 = j; j1 <= q; j1++) {
							board[i][j1] = ' ';
							board[p][j1] = ' ';
						}

						rects.push_back(Rectangle(i, j, p, q));
						return;
					}
				}
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cin >> n >> m;

	for(int32_t i = 1; i <= n; i++) {
		for(int32_t j = 1; j <= m; j++) {
			cin >> board[i][j];
			initBoard[i][j] = board[i][j];
		}
	}
	
	while(1) {
		int32_t cntRects = rects.size();
		FindRect();
		
		/**
		for(int32_t i = 1; i <= n; i++) {
			for(int32_t j = 1; j <= m; j++) {
				cout << board[i][j] << " ";
			}
			cout << endl;
		}
		*/

		if(cntRects == rects.size()) {
			break;
		}
	}
	
	for(int32_t i = 1; i <= n; i++) {
		for(int32_t j = 1; j <= m; j++) {
			if(initBoard[i][j] == '.' && board[i][j] != '.') { 
				return 8 / 0;
			}
		}
	}

	reverse(rects.begin(), rects.end());
	
	cout << rects.size () << endl;
	for(auto r : rects) {
		cout << r.x1 - 1 << " " << r.y1 - 1 << " " << r.x2 - 1 << " " << r.y2 - 1 << endl;
	}
	return 0;
}
