#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 1e5 + 5;

class Point {
public:
	int32_t x, y;

	Point(int32_t x = 0, int32_t y = 0) : x(x), y(y) {
		
	}

	bool operator< (const Point &other) const {
		if(x != other.x) {
			return x < other.x;
		}
		else {
			return y < other.y;
		}
	}
};

Point tops[MAX_N], bottoms[MAX_N];

int64_t CalcArea(const Point &bottom, const Point &top) {
	if(bottom.x > top.x || bottom.y > top.y) {
		return 0;
	}

	return 1ll * (1ll * top.x - 1ll * bottom.x) * (1ll * top.y - 1ll * bottom.y);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t n, m;
	cin >> n >> m;

		for(int32_t i = 1; i <= n; i++) {
			cin >> bottoms[i].x >> bottoms[i].y;
		}
		for(int32_t i = 1; i <= m; i++) {
			cin >> tops[i].x >> tops[i].y;
		}
	
	if(n <= 2000 && m <= 2000) {
		int64_t maxArea = 0;
		for(int32_t i = 1; i <= m; i++) {
			for(int32_t j = 1; j <= n; j++) {
				int64_t currArea = CalcArea(bottoms[j], tops[i]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}

		cout << maxArea << endl;
	}
	else {
		sort(bottoms + 1, bottoms + n + 1);
		
		int64_t maxArea = 0;
		for(int32_t i = 1; i <= m; i++) {
			for(int32_t j = 1; j <= min(100, n); j++) {
				int64_t currArea = CalcArea(bottoms[j], tops[i]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}

		cout << maxArea << endl;
	}

	return 0;
}
