#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 1e5 + 5;

bool sortByX = true;
bool sortByY = false;
bool sortBySum = false;
bool sortByProduct = false;

class Point {
public:
	int32_t x, y;

	Point(int32_t x = 0, int32_t y = 0) : x(x), y(y) {
		
	}

	bool operator< (const Point &other) const {
		if(sortByX) {
			if(x != other.x) {
				return x < other.x;
			}
			else {
				return y < other.y;
			}
		}
		else if(sortByY) {
			if(y != other.y) {
				return y < other.y;
			}
			else {
				return x < other.x;
			}
		}
		else if(sortBySum) {
			return x + y < other.x + other.y;
		}
		else if(sortByProduct) {
			return (1ll * x * y) < (1ll * other.x * other.y);
		}
	}
};

Point tops[MAX_N], bottoms[MAX_N];

int64_t CalcArea(const Point &bottom, const Point &top) {
	if(bottom.x > top.x || bottom.y > top.y) {
		return 0;
	}

	return 1ll * (1ll * top.x - 1ll * bottom.x) * (1ll * top.y - 1ll * bottom.y);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t n, m;
	cin >> n >> m;

		for(int32_t i = 1; i <= n; i++) {
			cin >> bottoms[i].x >> bottoms[i].y;
		}
		for(int32_t i = 1; i <= m; i++) {
			cin >> tops[i].x >> tops[i].y;
		}
	
	if(n <= 2000 && m <= 2000) {
		int64_t maxArea = 0;
		for(int32_t i = 1; i <= m; i++) {
			for(int32_t j = 1; j <= n; j++) {
				int64_t currArea = CalcArea(bottoms[j], tops[i]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}

		cout << maxArea << endl;
	}
	else {
		int64_t maxArea = 0;
		
		/**
		sort(bottoms + 1, bottoms + n + 1);
		
		for(int32_t i = 1; i <= m; i++) {
			for(int32_t j = 1; j <= min(10000000 / m, n); j++) {
				int64_t currArea = CalcArea(bottoms[j], tops[i]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}
		
		sortByX = false;
		sortByY = true;
		sort(bottoms + 1, bottoms + n + 1);

		for(int32_t i = 1; i <= m; i++) {
			for(int32_t j = 1; j <= min(10000000 / m, n); j++) {
				int64_t currArea = CalcArea(bottoms[j], tops[i]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}

		sortByY = false;
		sortBySum = true;
		sort(bottoms + 1, bottoms + n + 1);
		
		for(int32_t i = 1; i <= m; i++) {
			for(int32_t j = 1; j <= min(10000000 / m, n); j++) {
				int64_t currArea = CalcArea(bottoms[j], tops[i]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}

		sortBySum = false;
		sortByProduct = true;
		sort(bottoms + 1, bottoms + n + 1);

		for(int32_t i = 1; i <= m; i++) {
			for(int32_t j = 1; j <= min(10000000 / m, n); j++) {
				int64_t currArea = CalcArea(bottoms[j], tops[i]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}	
		*/	
		
		sortByX = true;
		sortByProduct = false;
		sort(tops + 1, tops + m + 1);
		
		for(int32_t i = 1; i <= n; i++) {
			for(int32_t j = m; j >= m - min(10000000 / n, m); j--) {
				int64_t currArea = CalcArea(bottoms[i], tops[j]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}
		
		sortByX = false;
		sortByY = true;
		sort(tops + 1, tops + m + 1);

		for(int32_t i = 1; i <= n; i++) {
			for(int32_t j = m; j >= m - min(10000000 / n, m); j--) {
				int64_t currArea = CalcArea(bottoms[i], tops[j]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}

		sortByY = false;
		sortBySum = true;
		sort(tops + 1, tops + m + 1);
		
		for(int32_t i = 1; i <= n; i++) {
			for(int32_t j = m; j >= m - min(10000000 / n, m); j--) {
				int64_t currArea = CalcArea(bottoms[i], tops[j]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}

		sortBySum = false;
		sortByProduct = true;
		sort(tops + 1, tops + m + 1);

		for(int32_t i = 1; i <= n; i++) {
			for(int32_t j = m; j >= m - min(10000000 / n, m); j--) {
				int64_t currArea = CalcArea(bottoms[i], tops[j]);
				if(currArea > maxArea) {
					maxArea = currArea;
				}
			}
		}
		
		cout << maxArea << endl;
	}

	return 0;
}
