#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 105;
const int32_t MAX_M = 105;

class Rectangle {
public:
	int32_t x1, y1, x2, y2;

	Rectangle(int32_t x1 = 0, int32_t y1 = 0, int32_t x2 = 0, int32_t y2 = 0) : x1(x1), y1(y1), x2(x2), y2(y2) {
		
	}
};

class IndexTree {
private:
	int32_t treeSize;
	int32_t data[MAX_N];

public:
	void Init(int32_t n) {
		treeSize = n;
		memset(data, 0, sizeof(data));
	}

	void Update(int32_t ind) {
		while(ind <= treeSize) {
			data[ind]++;
			ind += (ind & (-ind));
		}
	}

	int32_t Query(int32_t ind) {
		int32_t ans = 0;
		while(ind >= 1) {
			ans += data[ind];
			ind -= (ind & (-ind));
		}

		return ans;
	}
};

char board[MAX_N][MAX_M];
int32_t n, m;
IndexTree cntSpacesRow[MAX_N], cntSpacesCol[MAX_M];
set< int32_t > rowsDigs[MAX_N][5], colsDigs[MAX_M][5], rowsObst[MAX_N], colsObst[MAX_M], rows[MAX_N], cols[MAX_N];
vector< Rectangle > rects;

bool CheckIsPossibleDig(int32_t row, int32_t col, int32_t dig) {
	for(int32_t i = 1; i <= 4; i++) {
		if(i == dig) {
			if(rowsDigs[row][i].find(col) != rowsDigs[row][i].end()) {
				return true;
			}
		}
		else {
			if(rowsDigs[row][i].find(col) != rowsDigs[row][i].end()) {
				return false;
			}
		}
	}
	
	if(rowsObst[row].find(col) == rowsObst[row].end() && colsObst[col].find(row) == colsObst[col].end()) {
		return true;
	}
	else {
		return false;
	}
}

bool HasObstacleOnRow(int32_t row, int32_t from, int32_t to) {
	auto aux = rowsObst[row].lower_bound(from);
	
	if(aux != rowsObst[row].end() && *aux <= to) {
		return true;
	}

	for(int32_t i = 1; i <= 4; i++) {
		aux = rowsDigs[row][i].lower_bound(from);
	
		if(aux != rowsDigs[row][i].end() && *aux <= to) {
			return true;
		}
	}

	return false;
}

bool HasObstacleOnCol(int32_t col, int32_t from, int32_t to) {
	auto aux = colsObst[col].lower_bound(from);
	
	if(aux != colsObst[col].end() && *aux <= to) {
		return true;
	}

	for(int32_t i = 1; i <= 4; i++) {
		aux = colsDigs[col][i].lower_bound(from);
		
		if(aux != colsDigs[col][i].end() && *aux <= to) {
			return true;
		}
	}

	return false;
}

int32_t CntSpacesOnRow(int32_t row, int32_t from, int32_t to) {
	return cntSpacesRow[row].Query(to) - cntSpacesRow[row].Query(from - 1);
}

int32_t CntSpacesOnCol(int32_t col, int32_t from, int32_t to) {
	return cntSpacesCol[col].Query(to) - cntSpacesCol[col].Query(from - 1);
}

void ClearRow(int32_t row, int32_t from, int32_t to) {
	cout << "1 " << row << endl;
	while(1) {
		auto aux = rowsObst[row].lower_bound(from);
		
		if(aux == rowsObst[row].end() || *aux > to) {
			break;
		}

		if(cols[*aux].find(row) == cols[*aux].end()) {
			rowsObst[row].erase(aux);
			continue;
		}
			
		cntSpacesRow[row].Update(*aux);
		rowsObst[row].erase(aux);
	}

	while(1) {
		auto aux = rows[row].lower_bound(from);

		if(aux == rows[row].end() || *aux > to) {
			break;
		}

		cntSpacesRow[row].Update(*aux);
		rows[row].erase(aux);
	}
	
	for(int32_t i = 1; i <= 4; i++) {
		while(1) {
			auto aux = rowsDigs[row][i].lower_bound(from);
			
			if(aux == rowsDigs[row][i].end() || *aux > to) {
				break;
			}
			
			cntSpacesRow[row].Update(*aux);
			rowsDigs[row][i].erase(aux);
		}
	}
}

void ClearCol(int32_t col, int32_t from, int32_t to) {
	while(1) {
		auto aux = colsObst[col].lower_bound(from);
		
		if(aux == colsObst[col].end() || *aux > to) {
			break;
		}

		cntSpacesCol[col].Update(*aux);
		colsObst[col].erase(aux);
	}
	
	while(1) {
		auto aux = cols[col].lower_bound(from);
		
		if(aux == cols[col].end() || *aux > to) {
			break;
		}

		cntSpacesCol[col].Update(*aux);
		cols[col].erase(aux);
	}

	for(int32_t i = 1; i <= 4; i++) {
		while(1) {
			auto aux = colsDigs[col][i].lower_bound(from);
			
			if(aux == colsDigs[col][i].end() || *aux > to) {
				break;
			}

			cntSpacesCol[col].Update(*aux);
			colsDigs[col][i].erase(aux);
		}
	}
}

void FindRect() {
	for(int32_t i = 1; i <= n; i++) {
		for(int32_t j = 1; j <= m; j++) {
			if(!CheckIsPossibleDig(i, j, 1)) {
				continue;	
			}
			
			if(rects.size() == 1) {
				cout << " i " << i << " " << j << endl;
			}
			for(int32_t len = 2; len <= min(n - i, m - j) + 1; len++) {
				int32_t p = i + len - 1;
				int32_t q = j + len - 1;
				
				if(rects.size() == 1) {
					cout << i << " " << j << " " << p << " " << q << " aslkjhdjlkasd" << endl;
				}
				if(!CheckIsPossibleDig(i, q, 2) || !CheckIsPossibleDig(p, q, 3) || !CheckIsPossibleDig(p, j, 4)) {
					continue;
				}

				cout << "  lkjaskljfdasjnkjfdshkjfsahdfkasdhdf " << CheckIsPossibleDig(i, q, 2) << " " << CheckIsPossibleDig(i, q, 3) << " " << CheckIsPossibleDig(p, j, 4) << endl; 

				if(rects.size() == 1) {
					cout << "hkjhfdjkghkjdg " << i << " " << j << " " << p << " " << q << endl;
				}

				if(HasObstacleOnRow(i, j + 1, q - 1)) {
					continue;
				}
				if(HasObstacleOnRow(p, j + 1, q - 1)) {
					continue;
				}
				if(HasObstacleOnCol(j, i + 1, p - 1)) {
					continue;
				}
				if(HasObstacleOnCol(q, i + 1, p - 1)) {
					continue;
				}

				if(rects.size() == 1) {
					cout << "asdfdasfdas " << i << " " << j << " " << p << " " << q << endl; 
				}
				
				if(CntSpacesOnRow(i, j, q) == (q - j + 1) && CntSpacesOnRow(p, j, q) == (q - j + 1)
					&& CntSpacesOnCol(j, i, p) == (p - i + 1) && CntSpacesOnCol(q, i, p) == (p - i + 1)) {
					continue;
				}
				
				ClearRow(i, j, q);
				ClearRow(p, j, q);
				ClearCol(j, i, p);
				ClearCol(q, i, p);
			
				rects.push_back(Rectangle(i, j, p, q));
				return;
			}
		}
	}
}

int main() {
	//ios_base::sync_with_stdio(false);
	//cin.tie(nullptr);

	cin >> n >> m;

	for(int32_t i = 1; i <= n; i++) {
		for(int32_t j = 1; j <= m; j++) {
			cin >> board[i][j];
			
			if(board[i][j] >= '1' && board[i][j] <= '4') {
				rowsDigs[i][board[i][j] - '0'].insert(j);
				colsDigs[j][board[i][j] - '0'].insert(i);
			}
			else if(board[i][j] == '-') {
				colsObst[j].insert(i);
				rows[i].insert(j);
			}
			else if(board[i][j] == '|') {
				rowsObst[i].insert(j);
				cols[j].insert(i);
			}
			else {
				rowsObst[i].insert(j);
				colsObst[j].insert(i);
			}
		}
	}

	for(int32_t i = 1; i <= n; i++) {
		cntSpacesRow[i].Init(m);
	}
	for(int32_t i = 1; i <= m; i++) {
		cntSpacesCol[i].Init(n);
	}
	
	while(1) {
		int32_t cntRects = rects.size();
		FindRect();
		
		if(rects.size() == 2) {
			break;
		}
		if(cntRects == rects.size()) {
			break;
		}
	}
	
	reverse(rects.begin(), rects.end());
	
	cout << rects.size () << endl;
	for(auto r : rects) {
		cout << r.x1 - 1 << " " << r.y1 - 1 << " " << r.x2 - 1 << " " << r.y2 - 1 << endl;
	}
	return 0;
}
