#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e5 + 5;

int n,m;

struct point{

  long long x,y;

}l[N],r[N];

int orientation(point a, point b, point c)
{
    int res = (b.y - a.y) * (c.x - b.x) - (c.y - b.y) * (b.x - a.x);

    if(res > 0) /// clockwise
     return 1;
    if(res < 0)
     return -1;
    if(res == 0)
     return 0;
}

point rotor;
bool angle_sort(point s,point t)
{
    if(orientation(rotor, s, t) == 0)
        return s.x < t.x;

    if(orientation(rotor, s, t) == -1)
        return true;
    return false;
}

void convex_hull(point p[], int sz, vector <point> &hull)
{
    int i;

    for(i=2;i<=sz;i++)
    {
        if(p[i].y  < p[1].y)
            swap(p[1],p[i]);
        if(p[i].y == p[1].y)
          if(p[i].x < p[1].x)
            swap(p[1],p[i]);
    }
    rotor = p[1];

    sort(p + 2, p + sz + 2, angle_sort);

    for(i=1;i<=min(sz,3);i++)
        hull.pb(p[i]);

    for(i=4;i<=sz;i++)
    {
        int hull_sz = hull.size();
        while(hull_sz > 1 && orientation(hull[hull_sz - 2], hull[hull_sz - 1], p[i]) != -1)
        {
            hull.pop_back();
            hull_sz--;
        }
        hull.pb(p[i]);
    }
}

vector <point> hull_l, hull_r;

long long check(point pt1,point pt2)
{
    if(pt1.x >= pt2.x || pt1.y >= pt2.y)
      return 0;

    long long res = 1LL * (pt2.x - pt1.x) * (pt2.y - pt1.y);

    return res;
}

long long ans;

int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(NULL);
   cout.tie(NULL);

   int i,j;

   cin >> n >> m;
   for(i=1;i<=n;i++)
   {
       cin >> l[i].x >> l[i].y;
   }
   for(i=1;i<=m;i++)
   {
       cin >> r[i].x >> r[i].y;
   }

  // convex_hull(l, n, hull_l);
  // convex_hull(r, m, hull_r);

  /* for(i=0;i<hull_l.size();i++)
   {
       for(j=0;j<hull_r.size();j++)
       {
           ans = max(ans,check(hull_l[i], hull_r[j]));
       }
   } */

   for(i=1;i<=n;i++)
   {
       for(j=1;j<=m;j++)
       {
           ans = max(ans,check(l[i], r[j]));
       }
   }

   cout << ans << endl;

   return 0;
}


/*

3 4
4 5
5 3
2 8
9 6
8 8
0 0
4 10

*/
