#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e5 + 5;

int n,k;
vector <int> country[N];
int from[N];

bool vis[N];
vector <int> nb[N];
vector <int> rev_nb[N];

int groups;
int grp[N];

vector <int> pred;
bool in_pred[N];
bool in_cycle[N];
bool dead_end[N];

void DFS_Cycle(int v)
{
   vis[v] = true;
   in_pred[v] = true;
   pred.pb(v);

   for(int i=0;i<nb[v].size();i++)
   {
      if(from[nb[v][i]] != from[v])
        continue;

      if(vis[nb[v][i]] && in_pred[nb[v][i]])
      {
          for(int j=(int)pred.size() - 1;j>=0;j--)
          {
             in_cycle[pred[j]] = true;

             if(pred[j] == nb[v][i])
                break;
          }
      }

      if(!vis[nb[v][i]])
          DFS_Cycle(nb[v][i]);
   }

   pred.pop_back();
   in_pred[v] = false;
}

void DFS_Country(int v) /// in-country dead-ends
{
    vis[v] = true;
    grp[v] = groups;

    for(int i=0;i<rev_nb[v].size();i++)
    {
        if(from[rev_nb[v][i]] != from[v])
            continue;

        if(!vis[rev_nb[v][i]])
          DFS_Country(rev_nb[v][i]);
    }
}

map <pair <int,int> ,int> gtc; /// remembers if we have added edge from group i to country j

void DFS_Dead_End(int v,int rem = -1) /// cross-country dead ends
{
    vis[v] = true;

    if(rem != -1)
        grp[v] = rem;

    for(int i=0;i<rev_nb[v].size();i++)
    {
       if(from[v] == from[rev_nb[v][i]])
        continue;

       if(gtc[mp(grp[v],from[rev_nb[v][i]])] == 0)
       {
           groups++;
           gtc[mp(grp[v],from[rev_nb[v][i]])] = groups;
       }

       if(!vis[rev_nb[v][i]])
       {
           DFS_Dead_End(rev_nb[v][i], gtc[mp(grp[v],from[rev_nb[v][i]])]);
       }
    }
}

map < pair<int,int>, int> ctc;

vector <int> ans[N];

int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(NULL);
   cout.tie(NULL);

   int i,j;
   int r,x;

   cin >> n >> k;
   for(i=1;i<=k;i++)
   {
       cin >> r;
       for(j=1;j<=r;j++)
       {
           cin >> x;

           country[i].pb(x);
           from[x] = i;
       }
   }
   for(i=1;i<=n;i++)
   {
       cin >> x;

       nb[i].pb(x);
       rev_nb[x].pb(i);
   }

   for(i=1;i<=n;i++)
   {
       if(!vis[i])
       {
           DFS_Cycle(i);
       }
   }

   memset(vis,false,sizeof(vis));
   for(i=1;i<=n;i++)
   {
       if(in_cycle[i] && !vis[i])
       {
           groups++;
           DFS_Country(i);
       }
   }

   for(i=1;i<=n;i++)
   {
       if(from[ nb[i][0] ] == from[i])
        dead_end[i] = true;
   }

   memset(vis,false,sizeof(vis));
   for(i=1;i<=n;i++)
   {
       if(dead_end[i] && !vis[i])
       {
           DFS_Dead_End(i);
       }
   }

   /// only good, cross-country edges remain now

 /*  for(i=1;i<=n;i++)
   {
       cerr << grp[i] << endl;
   } */



   for(i=1;i<=n;i++)
   {
       ans[grp[i]].pb(i);
   }

   cout << groups << endl;
   for(i=1;i<=groups;i++)
   {
       cout << (int)ans[i].size() << " ";
       for(j=0;j<ans[i].size();j++)
       {
           cout << ans[i][j] << " ";
       }
       cout << endl;
   }

   return 0;
}


/*

12 2
6 1 2 3 10 4 5
6 7 8 9 12 6 11
4 5 6 7 8 9 2 1 3 11 12 3

*/

/*

4 1
4 1 2 3 4
2 3 4 2

*/
